include "console.iol"
include "time.iol"

type Heartbeat: void {
  .serverID: string
}

outputPort Server {
  Location: "socket://localhost:8000"
  Protocol: sodep
  OneWay: send( Heartbeat )
}

inputPort Client {
  Location: "socket://localhost:8001"
  Protocol: sodep
  OneWay: ack( Heartbeat )
}

inputPort ClientTimeout {
  Location: "local"
  OneWay: timeout( Heartbeat )
}

cset {
  id_server: Heartbeat.serverID
}

main
{
  heartbeat.serverID = "MyServer";
  csets.id_server = heartbeat.serverID;

  send@Server( heartbeat );

  tmsg = 490;
  tmsg.operation = "timeout";
  tmsg.message.serverID = heartbeat.serverID;
  setNextTimeout@Time( tmsg );
  [ timeout() ]{ println@Console( "timeout" )() }
  [ ack() ]{ println@Console( "received ack" )() }
}
